package ass.sivakfil;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.File;
import java.io.IOException;

import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JTextArea;
import javax.swing.JTextField;

/** 
 * @author AwesomeProgrammerDude
 * DONT TOUCH MY CODE!
 */
public class ChatView {
	
	protected JFrame frame = new JFrame();
	protected JPanel vertical = new JPanel();
	
	// !!! keep cols of messages and newMessageInput same !!!
	protected final JTextArea messages = new JTextArea(15, 80);
	protected final JTextField newMessageInput = new JTextField(80);
	protected JButton btnSend = new JButton("Send");
	
	public ChatView(final MessageRepository msgRepo) throws IOException {
		// makes messages readonly
		messages.setEditable(false);
		
		vertical.setLayout(new BoxLayout(vertical, BoxLayout.Y_AXIS));
		vertical.add(messages);
		
		JPanel horizontal = new JPanel();
		horizontal.setLayout(new BoxLayout(horizontal, BoxLayout.X_AXIS));
		
		horizontal.add(newMessageInput);
		horizontal.add(btnSend);
		
		vertical.add(horizontal);
		
		frame.setTitle("Chat window");
		frame.add(vertical);
		frame.setVisible(true);
		
		// adjusts window to size of components 
		frame.pack();
		
		// load messages to textarea
		String msgs = "";
		for(String message : msgRepo) {
			msgs += message + "\n";
		}
		messages.setText(msgs);
		
		btnSend.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				String message = newMessageInput.getText();
				msgRepo.add(message);
				try {
					msgRepo.save();
				} catch (IOException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
				}
				
				newMessageInput.setText("");
			}
		});
		
		frame.addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				e.getWindow().setVisible(false);
				System.exit(0);
			} 
		});
	}
	
	public void notifyChange(String message) {
		messages.setText(messages.getText() + message + "\n");
	}
	
}

